'''''''''''''''''''''''''''''''''''''''''''''
'
'  Filter Registration Utility  
'
'''''''''''''''''''''''''''''''''''''''''''''

'  Description:
'  ------------
'  This sample admin script allows you to install a new ISAPI filter on the server or
'  the service.
'
'  To Run:  
'  -------
'  This is the format for this script:
'  
'      cscript registerISAPIFilter.vbs <filterpath> [-n <filtername>]
'  
'  NOTE:  If you want to execute this script directly from Windows, use 
'  'wscript' instead of 'cscript'. 
'
'''''''''''''''''''''''''''''''''''''''''''''

Option Explicit

' Initialize error checking
'On Error Resume Next

' Initialize variables
Dim ArgCount, FName, FPath, FiltersObj, FilterObj, FullPath, LoadOrder

' Default values
ArgCount = 0
FName = ""  ' Name of filter
FPath = ""      ' Path to filter DLL



  ' ** Parse Command Line

    ' Loop through arguments
    While ArgCount < Wscript.Arguments.Count
      
      ' Determine switches used
      Select Case Wscript.Arguments(ArgCount)

         Case "-h", "-?", "/?":    ' Help!
            Call UsageMsg

         Case Else:
            If Wscript.Arguments(ArgCount) <> "" Then  ' Only one name allowed
	       FName = Wscript.Arguments(ArgCount)               
            Else
	       Call UsageMsg
            End If

      End Select

      ' Move pointer to next argument
      ArgCount = ArgCount + 1

    Wend

    ' Set filter name to path, if none provided
    If FName = "" Then FName = FPath
	
	on error resume next			
	call filtersobj.delete("IIsFilter", FName)

    Wscript.Echo "Filter " & FName & " has been unregistered."
    Wscript.Quit(0)


' Displays usage message, then QUITS
Sub UsageMsg
   Wscript.Echo "Usage:  cscript UnRegisterISAPIFilter.vbs <FilterName> "
   Wscript.Quit
End Sub





